<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "scan_template_listing_type_version".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ScanTemplateListingTypeVersion".
 *
 * Columns in table "scan_template_listing_type_version" available as properties of the model,
 * followed by relations of table "scan_template_listing_type_version" available as properties of the model.
 *
 * @property integer $id
 * @property integer $scan_template_version
 * @property integer $scan_template_listing_type_id
 * @property integer $listing_type_id
 * @property integer $scan_template_id
 * @property integer $max_age
 * @property string $weight
 * @property string $section
 * @property integer $provider_primary_only
 * @property integer $provider_secondary_only
 * @property string $date_added
 * @property string $date_updated
 * @property string $version_date_added
 *
 * @property ListingType $listingType
 * @property ScanTemplate $scanTemplate
 */
abstract class BaseScanTemplateListingTypeVersion extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'scan_template_listing_type_version';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ScanTemplateListingTypeVersion|ScanTemplateListingTypeVersions', $n);
    }

    public static function representingColumn()
    {
        return 'weight';
    }

    public function rules()
    {
        return array(
            array('scan_template_version, scan_template_listing_type_id, listing_type_id, scan_template_id, weight, section, provider_primary_only, provider_secondary_only, date_added, date_updated', 'required'),
            array('scan_template_version, scan_template_listing_type_id, listing_type_id, scan_template_id, max_age, provider_primary_only, provider_secondary_only', 'numerical', 'integerOnly' => true),
            array('weight', 'length', 'max' => 5),
            array('section', 'length', 'max' => 12),
            array('version_date_added', 'safe'),
            array('max_age, version_date_added', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, scan_template_version, scan_template_listing_type_id, listing_type_id, scan_template_id, max_age, weight, section, provider_primary_only, provider_secondary_only, date_added, date_updated, version_date_added', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'listingType' => array(self::BELONGS_TO, 'ListingType', 'listing_type_id'),
            'scanTemplate' => array(self::BELONGS_TO, 'ScanTemplate', 'scan_template_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'scan_template_version' => Yii::t('app', 'Scan Template Version'),
            'scan_template_listing_type_id' => Yii::t('app', 'Scan Template Listing Type'),
            'listing_type_id' => null,
            'scan_template_id' => null,
            'max_age' => Yii::t('app', 'Max Age'),
            'weight' => Yii::t('app', 'Weight'),
            'section' => Yii::t('app', 'Section'),
            'provider_primary_only' => Yii::t('app', 'Provider Primary Only'),
            'provider_secondary_only' => Yii::t('app', 'Provider Secondary Only'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'version_date_added' => Yii::t('app', 'Version Date Added'),
            'listingType' => null,
            'scanTemplate' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('scan_template_version', $this->scan_template_version);
        $criteria->compare('scan_template_listing_type_id', $this->scan_template_listing_type_id);
        $criteria->compare('listing_type_id', $this->listing_type_id);
        $criteria->compare('scan_template_id', $this->scan_template_id);
        $criteria->compare('max_age', $this->max_age);
        $criteria->compare('weight', $this->weight, true);
        $criteria->compare('section', $this->section, true);
        $criteria->compare('provider_primary_only', $this->provider_primary_only);
        $criteria->compare('provider_secondary_only', $this->provider_secondary_only);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);
        $criteria->compare('version_date_added', $this->version_date_added, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
